/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.simulator.execute;

import de.steamwar.bausystem.features.tracer.TraceRecorder;
import de.steamwar.bausystem.region.flags.Flag;
import de.steamwar.bausystem.utils.PasteBuilder;
import de.steamwar.bausystem.utils.bossbar.BauSystemBossbar;

public class StabFinalizer extends StabStep {

    public StabFinalizer(StabData data) {
        super(data);
    }

    @Override
    protected void start() {
        try {
            PasteBuilder.ClipboardProvider clipboardProvider = new PasteBuilder.ClipboardProviderImpl(data.clipboard);
            PasteBuilder pasteBuilder = new PasteBuilder(clipboardProvider);
            if (data.region.getRegionData().has(Flag.COLOR).isReadable()) {
                pasteBuilder.color(data.region.getRegionData().get(Flag.COLOR).getWithDefault());
            }
            data.region.getTestblockArea().reset(pasteBuilder, true);
        } catch (SecurityException e) {
            stop();
            throw e;
        }

        TraceRecorder.instance.startRecording(data.region);
        runSimulator(() -> {
            TraceRecorder.instance.stopRecording(data.region);
            stop();
        });
    }

    @Override
    protected void bossbar(BauSystemBossbar bossbar, boolean stopped) {
        bossbar.setProgress(Math.min(data.currentDepth / (double) data.depthLimit, 1.0));
        bossbar.setTitle("§e" + data.currentDepth + "§8/§7" + data.depthLimit);
    }
}
